### eraseskysub.cl
###

procedure eraseskysub (fflst, ffobjlst, sslst)

file fflst    {prompt = "Flat fielded image list name with @mark"}
file ffobjlst {prompt = "Object subtracted ff image list name with @mark"}
file sslst    {prompt = "Sky subtracted image list name with @mark"}
int ndthpos   {9,prompt = "Number of dithering position"}
int iteranum  {50,prompt = "Max iteration number for statistic"}
int nsigma    {3,prompt = "Sigma rejection limit"}
struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
struct *list3  {mode = 'h'}

begin

	char ff,ss,ffobj,ssobj,sky
	char ff_subset, ss_subset, ffobj_subset
	char tmp_fffile,tmp_ssfile,tmp_ffobjfile
	char tmp_skyimg,tmp_nmskyimg
	char ff_name,ffobj_name,ss_name
	char ff_root, ffobj_root, ss_root
	real bg_med
	int npos, dthpos_pre, dthpos
	int itnum,nsig
	int i, imax
	
	ff = fflst
	ss = sslst
	ffobj = ffobjlst
	npos = ndthpos
	itnum = iteranum
	nsig = nsigma

	tmp_fffile = mktemp("tmp_file.")
	sections(ff,option='fullname',> tmp_fffile)

	tmp_ffobjfile = mktemp("tmp_file.")
	sections(ffobj,option='fullname',> tmp_ffobjfile)

	tmp_ssfile = mktemp("tmp_file.")
	sections(ss,option='fullname',> tmp_ssfile)

	list1 = tmp_fffile
	list2 = tmp_ffobjfile
	list3 = tmp_ssfile

	ff_root = mktemp("tmp_ffroot.")
	ffobj_root = mktemp("tmp_ffobjroot.")
	ss_root = mktemp("tmp_ssroot.")

	i = 0
	dthpos_pre = 100
	while(fscan(list1, ff_name) != EOF){
	  if(fscan(list2, ffobj_name) != EOF){
	    if(fscan(list3, ss_name) != EOF){
	      hselect(ff_name, "I_DTHPOS", yes) | scan(dthpos)
	      if(dthpos < 1 || dthpos > ndthpos){
	        print("Error: Cannot read I_DTHPOS")
		bye
	      }
	      if(dthpos < dthpos_pre){
	        i += 1
	        print(ff_root//"_"//i//".lst") | scan(ff_subset) 
	        print(ffobj_root//"_"//i//".lst") | scan(ffobj_subset) 
	        print(ss_root//"_"//i//".lst") | scan(ss_subset) 
	        print(ff_name, > ff_subset) 
	        print(ffobj_name, > ffobj_subset)
	        print(ss_name, > ss_subset)
		dthpos_pre = dthpos 
	      }else{
	        print(ff_name, >> ff_subset)
	        print(ffobj_name, >> ffobj_subset)
	        print(ss_name, >> ss_subset)
		dthpos_pre = dthpos 
	      }
            }
          }
        }
	imax = i

	for(i=1; i<=imax;i+=1){
          print(ff_root//"_"//i//".lst") | scan(ff_subset) 
	  print(ffobj_root//"_"//i//".lst") | scan(ffobj_subset) 
          print(ss_root//"_"//i//".lst") | scan(ss_subset) 

	  tmp_skyimg = mktemp("tmp_img.")
	  zcombine ("@"//ffobj_subset, tmp_skyimg, comb="median", rej="sigclip", proj=no, outtyp="real", offset="none", masktyp="none", maskval=0., blan=0., scal="none", weigh="none", zerop="midpt", lthresh=INDEF, hthresh=INDEF, nlo=1., nhig=1., nkee=1., mcli=yes, lsig=3., hsig=3.)

	  imstat (tmp_skyimg, fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
	  print ("\n### Sky background median = ",bg_med,"###\n")
	  tmp_nmskyimg = mktemp("tmp_img.")
          imarith (tmp_skyimg,"/",bg_med,tmp_nmskyimg,ver+)
	  imdel(tmp_skyimg)
	      
	  list1 = ff_subset
	  list2 = ffobj_subset
	  list3 = ss_subset

	  while (fscan(list1,ff_name) != EOF) {
	    if(fscan(list2,ffobj_name) != EOF){
	      if(fscan(list3,ss_name) != EOF){
	        imstat (ffobj_name, fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
		print ("\n### ",ff_name," background median = ",bg_med,"###\n")
		tmp_skyimg = mktemp("tmp_img.")
		imarith (tmp_nmskyimg,"*",bg_med, tmp_skyimg,ver+)
		imarith (ff_name,"-",tmp_skyimg, ss_name,ver+)
		imdel(tmp_skyimg)
	      }
	    }
          }
	  
	  imdel(tmp_nmskyimg)
 	  del (ff_subset,ver-,>&"dev$null")
	  del (ffobj_subset,ver-,>&"dev$null")
	  del (ss_subset,ver-,>&"dev$null")
	}
	
        del (tmp_fffile, ver-, >&"dev$null")
	del (tmp_ffobjfile, ver-, >&"dev$null")
	del (tmp_ssfile, ver-, >&"dev$null")

end
