# Image reduction script ver.3.0 for IRAF v2.12 
# Yosuke Minowa (2008/06/30)

procedure flatfield(rawlist,outlist,flatimg)

file    rawlist    {prompt = "Input raw data list with @mark"}
file    outlist    {prompt = "Output data list with @mark"}
file    flatimg    {prompt = "Flat image name"}
bool    subdark    {no, prompt = "Subtract dark frame?"}
file    darkimg    {prompt = "Dark frame normalized by COADDS*NDR "}
bool	bpfix	   {no, prompt = "Fix badpixel?"}
file	bpmask     {prompt = "Badpixel mask"}
struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
struct *list3  {mode = 'h'}

begin
	char _rawlist,_outlist,_flatimg,_darkimg, _bpmask
	char tmp_objfile, tmp_norm, tmp_output
	real coadd, ndr, exp, fac
	char fname1, fname2

	_rawlist = rawlist
	_outlist = outlist
	_flatimg = flatimg
	_darkimg = darkimg
	_bpmask = bpmask

	tmp_norm = mktemp("tmp_file.")
	hselect(_rawlist,"COADDS,NDR,EXP1TIME","yes",> tmp_norm)

	tmp_objfile = mktemp("tmp_file.")
	sections(_rawlist,option='fullname',>tmp_objfile)

	tmp_output = mktemp("tmp_file.")
	sections(_outlist,option='fullname',>tmp_output)

	list1 = tmp_objfile
	list2 = tmp_norm
	list3 = tmp_output

	while(fscan(list1,fname1) != EOF){
		if(fscan(list2, coadd, ndr, exp) != EOF){
			fac = coadd * ndr
		}

		if(fscan(list3, fname2) != EOF){
			imarith(fname1,"/",fac,fname2,ver+)
			if (subdark) {
				imarith (fname2,"-",_darkimg,fname2,ver-)
			}
			imarith (fname2, "/", _flatimg, fname2,ver-)
			imarith (fname2,"/",exp,fname2,ver-)			
		}
	}
	
	if(bpfix){
		fixpix("@"//tmp_output, _bpmask,ver-)
		fixpix("@"//tmp_output, _bpmask,ver-)
		fixpix("@"//tmp_output, _bpmask,ver-)
	}

	del(tmp_norm, ver-,>& "dev$null")
	del(tmp_objfile, ver-,>& "dev$null")
	del(tmp_output, ver-,>& "dev$null")

end
