procedure imshiftcomb(input,output,offset)

file input   {prompt="List of input images with @mark"}
file output  {prompt="Output combined image"}
file offset  {prompt="Input image offsets"}
bool expw    {no,prompt="Create exposure map?"}
file expmap  {prompt="Name of exposure map"}
int imgsize  {1536,prompt="Print image size"}

struct  *list1 {mode = 'h'}
struct  *list2 {mode = 'h'}
#
begin
  string in,out,off,expm
  string tmpfile0,tmpfile1,tmpfile2,tmpfile3,tmpfile4
  string tmp_expfile, tmp_expimg
  string tmpimg1,tmpimg2,tmpimg3,tmpimg4
  string tmpmask,tmpmask2,tmpzeroim
  string fname1,fname2
  string expweight,zeroshift
  real med
  real dx,dy,dx_min,dx_max,dy_min,dy_max
  int xmin,xmax,ymin,ymax
  int min,max
  int num
  int size
  char lim

  in = input
  out = output
  off = offset
  size = imgsize
  expm = expmap

### calculate center position ###
  min = (size - 1024)/2 + 1
  max = 1024 + (size - 1024)/2

  lim = "["//min//":"//max//","//min//":"//max//"]"

### Prepare for exposure weight ###
  expweight = mktemp("temp_file.")
  hselect(in,"exp1time","yes",> expweight)

  tmpfile0 = mktemp("tmp_file.")
  imstat (in, fields="midpt", lower=INDEF, upper=INDEF, nclip=50, lsigma=3., usigma=3., binwidth=0.1, format=no, cache=no, > tmpfile0)

### Prepare for zero shift ###
  zeroshift = mktemp("tmp_file.")

  list1 = tmpfile0
  while(fscan(list1,med) != EOF){
    med = med * (-1)
    print(med,>> zeroshift)
  }

  del(tmpfile0)


### making mask template ###
  tmpzeroim = mktemp("temp_img.")
  tmpmask = mktemp("temp_img.")
  mkpattern (tmpzeroim, output="", pattern="constant", option="replace", v1=0., v2=1., size=1, title="mask", pixtype="real", ndim=2, ncols=1024, nlines=1024, n3=1, n4=1, n5=1, n6=1, n7=1, header="")
  mkpattern (tmpmask, output="", pattern="constant", option="replace", v1=1., v2=1., size=1, title="mask", pixtype="real", ndim=2, ncols=size, nlines=size, n3=1, n4=1, n5=1, n6=1, n7=1, header="")

  imcopy(tmpzeroim,tmpmask//lim,ver-)

  imdel(tmpzeroim)

### copy image on larger format ###
  tmpfile1 = mktemp("tmp_file.")
  sections(in,option='fullname', > tmpfile1)

  list1 = tmpfile1

  tmpfile2 = mktemp("tmp_file.")
  tmpfile3 = mktemp("tmp_file.")
  tmpfile4 = mktemp("tmp_file.")

  while(fscan(list1,fname1) != EOF){
    tmpimg1 = mktemp("temp_img.")
    tmpmask2 = mktemp("temp_img.")
    mkpattern (tmpimg1, output="", pattern="constant", option="replace", v1=0., v2=1., size=1, title="", pixtype="real", ndim=2, ncols=size, nlines=size, n3=1, n4=1, n5=1, n6=1, n7=1, header=fname1)
    imcopy(fname1,tmpimg1//lim,ver-)
    print(tmpimg1,>>tmpfile2)
    print(tmpmask,>>tmpfile3)
    print(tmpmask2,>>tmpfile4)
  }


### Image and mask shift ###
  imshift ("@"//tmpfile2, "@"//tmpfile2, 0., 0., shifts_file=off, interp_type="linear", boundary_typ="constant", constant=0.)
  imshift ("@"//tmpfile3, "@"//tmpfile4, 0., 0., shifts_file=off, interp_type="linear", boundary_typ="constant", constant=1.) 

  imdel(tmpmask)
  del(tmpfile3)

### Write the name of mask file to image header ###
  list1 = tmpfile2
  list2 = tmpfile4

  while(fscan(list1,fname1) != EOF){
    if(fscan(list2,fname2) != EOF){
      hedit(fname1,"bpm",fname2,add=yes,verify=no)
    }
  }

### combine image ###
  tmpimg2 = mktemp("tmp_img.")
  tmpimg3 = mktemp("tmp_img.")

  imcombine ("@"//tmpfile2, tmpimg3, headers="", bpmasks="", rejmasks="", nrejmasks="", expmasks="", sigmas="", logfile="STDOUT", combine="average", reject="sigclip", project=no, outtype="real", outlimits="", offsets="none", masktype="!bpm", maskvalue=0., blank=0., scale="none", zero="@"//zeroshift, weight="@"//expweight, statsec="", expname="", lthreshold=INDEF, hthreshold=INDEF, nlow=1, nhigh=1, nkeep=1, mclip=yes, lsigma=3., hsigma=3., rdnoise="0.", gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)


### Calculate the image cutting region ###
  list1 = off

  num = 1;

  print("Cutting image...")
  while(fscan(list1,dx,dy) != EOF){
    if(num == 1){
      dx_min = dx
      dx_max = dx
      dy_min = dy
      dy_max = dy
    } else {
      if(dx > dx_max){
        dx_max = dx
      } else if(dx < dx_min){
        dx_min = dx
      }
      
      if(dy > dy_max){
        dy_max = dy
      } else if(dy < dy_min){
        dy_min = dy
      }
    }
    num += 1
  }

  xmin = int((size-1024)/2 + 1 + dx_min)
  xmax = int((size-1024)/2 + 1024 + dx_max)

  ymin = int((size-1024)/2 + 1 + dy_min)
  ymax = int((size-1024)/2 + 1024 + dy_max)

  lim = "["//xmin//":"//xmax//","//ymin//":"//ymax//"]"


### Cut combined image ###
  imcopy(tmpimg3//lim,out)

### Create exposure map
  if(expw){
    list = tmpfile2
    tmp_expfile = mktemp("tmp_file.")
    while(fscan(list,fname1) != EOF){
      tmp_expimg = mktemp("tmp_img.")
      imarith(fname1, "*", 0, tmp_expimg)
      print(tmp_expimg, >> tmp_expfile)
    }
    imarith("@"//tmp_expfile, "+", "@"//expweight, "@"//tmp_expfile)
    tmpimg4 = mktemp("tmp_img.")
    imcombine ("@"//tmp_expfile, tmpimg4, headers="", bpmasks="", rejmasks="", nrejmasks="", expmasks="", sigmas="", logfile="STDOUT", combine="sum", reject="none", project=no, outtype="real", outlimits="", offsets="none", masktype="!bpm", maskvalue=0., blank=0., scale="none", zero="none", weight="none", statsec="", expname="", lthreshold=INDEF, hthreshold=INDEF, nlow=1, nhigh=1, nkeep=1, mclip=yes, lsigma=3., hsigma=3., rdnoise="0.", gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)            

    imcopy(tmpimg4//lim,expm)
    imdel(tmpimg4)
    imdel("@"//tmp_expfile)
    del(tmp_expfile)
  }
### Delete temporary file ###
  imdel("@"//tmpfile2)
  imdel("@"//tmpfile4)
  imdel(tmpimg3)
  del(tmpfile1)
  del(tmpfile2)
  del(tmpfile4)
  del(expweight)
  del(zeroshift)

end
