###  CALFLAT making script for IRAF v2.12
###  Yosuke Minowa (2008/06/29)
procedure mkcalflat (calonlist, calofflist, output)
	
file    calonlist    {prompt = "Input cal on image list with @mark"}
file    calofflist   {prompt = "Input cal off image list with @mark"}
file    output       {prompt = "Output cal flat image name"}
file    mask         {"none",prompt = "Bad pixel mask image name if available"}

begin
	char _calonlist,_calofflist
	char _output
	char _mask
	char tmp_onfile,tmp_calfile
	char tmp_offimg, tmp_calimg
	char fname
	real mn

	_calonlist = calonlist
	_calofflist = calofflist
	_output = output
	_mask = mask

	tmp_offimg = mktemp("tmp_img.")

	imcombine (_calofflist, tmp_offimg, headers="", bpmasks="",
	rejmasks="", nrejmasks="", expmasks="", sigmas="",
	logfile="STDOUT", combine="median", reject="sigclip",
	project=no, outtype="real", outlimits="", offsets="none",
	masktype="none", maskvalue=0, blank=0, scale="none",
	zero="none", weight="none", statsec="", expname="",
	lthreshold=INDEF, hthreshold=INDEF, nlow=1., nhigh=1.,
	nkeep=1., mclip=yes, lsigma=3, hsigma=3, rdnoise="0.",
	gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)

	tmp_onfile = mktemp("tmp_file.")
	sections(_calonlist,option='fullname',>tmp_onfile)

	list = tmp_onfile

	tmp_calfile = mktemp("tmp_file.")

	while (fscan(list,fname) != EOF) {
		tmp_calimg = mktemp("tmp_img.")
		imarith (fname,"-",tmp_offimg,tmp_calimg,ver-)

		if(_mask == "none"){		  
		  imstat (tmp_calimg,fields="mean",nclip=50,lsigma=3,usigma=3,binwidth=0.1,format=no,cache=no) | scan(mn)
		  print ("### Average of ",fname," = ",mn)
		}else{
       		  mimstat (tmp_calimg,imasks=_mask,omasks="",fields="mean",nclip=50,lower=INDEF,upper=INDEF,lsigma=3,usigma=3,binwidth=0.1,format=no,cache=no) | scan(mn)
		  print ("### Masked average of ",fname," = ",mn)
		}
		imarith (tmp_calimg,"/",mn,tmp_calimg,ver-)
		print (tmp_calimg,>>tmp_calfile)
	}

	imcombine ("@"//tmp_calfile, _output, headers="", bpmasks="",
	rejmasks="", nrejmasks="", expmasks="", sigmas="",
	logfile="STDOUT", combine="median", reject="sigclip",
	project=no, outtype="real", outlimits="", offsets="none",
	masktype="none", maskvalue=0, blank=0, scale="none",
	zero="none", weight="none", statsec="", expname="",
	lthreshold=INDEF, hthreshold=INDEF, nlow=1., nhigh=1.,
	nkeep=1., mclip=yes, lsigma=3, hsigma=3, rdnoise="0.",
	gain="1.", snoise="0.", sigscale=0.1, pclip=-0.5, grow=0.)

	imstat (_output, fields="image,npix,mean,stddev,min,max", lower=INDEF, upper=INDEF, nclip=0, lsigma=3., usigma=3., binwidth=0.1, format=yes, cache=no)

	del (tmp_onfile,ver-,>&"dev$null")
	imdel("@"//tmp_calfile)
	del (tmp_calfile,ver-,>&"dev$null")
	imdel (tmp_offimg)
end
