### maskskysub.cl
### Yosuke Minowa (2008/06/30)

procedure maskskysub (fflist,skyimg, sslist,masklist)

file fflist   {prompt = "List of flat fielded frames with @mark"}
file skyimg   {prompt = "Sky frame"}
file masklist {prompt = "List of mask frames with @mark"}
file sslist   {prompt = "List of sky subtracted frames with @mark"}
int iteranum  {50,prompt = "Max iteration number for statistic"}
int nsigma    {3,prompt = "Sigma rejection limit"}
struct *list1  {mode = 'h'}
struct *list2  {mode = 'h'}
struct *list3  {mode = 'h'}

begin
	char _fflist, _sslist, _masklist, _skyimg
	char tmp_fffile, tmp_maskfile, tmp_ssfile
	char tmp_skyimg,tmp_nmskyimg
	char ff_name,mask_name,ss_name
	real bg_med
	int itnum,nsig

	_fflist = fflist
	_sslist = sslist
	_masklist = masklist
	_skyimg = skyimg

	itnum = iteranum
	nsig = nsigma

	tmp_fffile = mktemp("tmp_file.")
	sections(_fflist,option='fullname',> tmp_fffile)

	tmp_maskfile = mktemp ("tmp_file.")		
	sections (_masklist,option='fullname',>tmp_maskfile)

	tmp_ssfile = mktemp ("tmp_file.")		
	sections (_sslist,option='fullname',>tmp_ssfile)

	imstat (_skyimg, fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
	tmp_nmskyimg = mktemp("tmp_file.")
	print ("\n### Sky background median = ",bg_med,"###\n")
	imarith (_skyimg,"/",bg_med,tmp_nmskyimg,ver+)

        list1 = tmp_fffile
	list2 = tmp_maskfile
	list3 = tmp_ssfile
	
        while (fscan(list1,ff_name) != EOF) {
	    if (fscan (list2,mask_name) != EOF) {
		mimstat (ff_name, imasks=mask_name//"[pl]", omasks="", fields="midpt", lower=INDEF, upper=INDEF, nclip=itnum, lsigma=nsig, usigma=nsig, binwidth=0.1, format=no, cache=no) | scan (bg_med)
		print ("\n### ",ff_name," background median = ",bg_med,"###\n")
		tmp_skyimg = mktemp("tmp_img.")
		imarith (tmp_nmskyimg,"*",bg_med, tmp_skyimg,ver+)

		if (fscan (list3,ss_name) != EOF) {
		    imarith (ff_name,"-",tmp_skyimg, ss_name,ver+)
		    imdel(tmp_skyimg)
		}
	    }
         }

       imdel(tmp_nmskyimg)
       del (tmp_fffile, ver-, >&"dev$null")
       del (tmp_maskfile, ver-, >&"dev$null")
       del (tmp_ssfile, ver-, >&"dev$null")

end
