#!/usr/bin/perl

if($#ARGV != 1){
    if($#ARGV !=3){
	print "Usage: ./objaperture.pl <image> <output> [-c <config>]\n";
	exit;
    }else{
	if($ARGV[2] ne "-c"){
	    print "Usage: ./objaperture.pl <image> <output> [-c <config>]\n";
	    exit;
	}else{
	    if(-e $ARGV[3]){
		$config = $ARGV[3];
	    }else{
		print("Configuration file $ARGV[3] is not exist\n");
		exit;
	    }
	}
    }
}

$default_config = "objaperture_default.sex";
system("sex -d > $default_config");

$param = "objaperture_pl.param";
open(OUT,"> $param");
print OUT <<EOF;
X_IMAGE
Y_IMAGE
KRON_RADIUS
A_IMAGE
B_IMAGE
ISOAREA_IMAGE
EOF
close(OUT);

$conv = "objaperture_pl.conv";
open(OUT,"> $conv");
print OUT <<EOF;
CONV NORM
# 3x3 ``all-ground'' convolution mask with FWHM = 2 pixels.
1 2 1
2 4 2
1 2 1
EOF
close(OUT);

if($#ARGV == 1){ 
    $config = "objaperture_pl.sex";
    open(IN,$default_config);
    open(OUT,"> $config");
    while(<IN>){
	chop;
	@param = split(/\s+/,$_);
	if($param[0] eq "CATALOG_TYPE"){
	    print OUT "$param[0] ASCII\n";
	}elsif($param[0] eq "PARAMETERS_NAME"){
	    print OUT "$param[0] $param\n";
	}elsif($param[0] eq "DETECT_MINAREA"){
	    print OUT "$param[0] 50\n";
	}elsif($param[0] eq "ANALYSIS_THRESH"){
	    print OUT "$param[0] 1.0\n";
	}elsif($param[0] eq "FILTER_NAME"){
	    print OUT "$param[0] $conv\n";
	}elsif($param[0] eq "DEBLEND_NTHRESH"){
	    print OUT "$param[0] 16\n";
	}elsif($param[0] eq "DEBLEND_MINCONT"){
	    print OUT "$param[0] 0.01\n";
	}elsif($param[0] eq "PIXEL_SCALE"){
	    print OUT "$param[0] 0.058\n";
	}else{
	    print OUT "$_\n";
	}
    }
    close(IN);
    close(OUT);
}

$cat = time.".cat";    
system("sex -c $config -CATALOG_NAME $cat $ARGV[0] ");

open(IN,$cat);
open(OUT,"> $ARGV[1]");
while(<IN>){
    chop;
    @param = split(/\s+/,$_);
    $x = $param[1];
    $y = $param[2];
    $r_kron = $param[3] * $param[4];
    $r_iso = sqrt($param[6] / 3.14);
    if($r_kron > $r_iso){
	printf OUT ("%.3f %.3f %.3f\n",$x,$y,$r_kron);
    }else{
	printf OUT ("%.3f %.3f %.3f\n",$x,$y,$r_iso);
    }
}
close(IN);
close(OUT);

system("rm -rf $cat");
system("rm -rf $default_config");

